/**
 * 1. FormItem网格布局
 * 2. 居中，居右，居左布局
 * 3. 行内布局
 * 4. 吸底布局
 */
import React from 'react';
import { ReactFC } from '@formily/react';
import { SpaceProps } from 'antd/lib/space';
import { IFormItemProps } from '../form-item';
import StickyBox from 'react-sticky-box';
interface IStickyProps extends React.ComponentProps<typeof StickyBox> {
    align?: React.CSSProperties['textAlign'];
}
declare type IFormButtonGroupProps = Omit<SpaceProps, 'align' | 'size'> & {
    align?: React.CSSProperties['textAlign'];
    gutter?: number;
};
declare type ComposedButtonGroup = ReactFC<IFormButtonGroupProps> & {
    Sticky: ReactFC<React.PropsWithChildren<IStickyProps>>;
    FormItem: ReactFC<IFormItemProps & {
        gutter?: number;
    }>;
};
export declare const FormButtonGroup: ComposedButtonGroup;
export default FormButtonGroup;
