import React from 'react';
import { Tooltip } from 'antd';
export interface IFormItemProps {
    className?: string;
    style?: React.CSSProperties;
    prefixCls?: string;
    label?: React.ReactNode;
    colon?: boolean;
    tooltip?: React.ReactNode | React.ComponentProps<typeof Tooltip>;
    tooltipIcon?: React.ReactNode;
    layout?: 'vertical' | 'horizontal' | 'inline';
    tooltipLayout?: 'icon' | 'text';
    labelStyle?: React.CSSProperties;
    labelAlign?: 'left' | 'right';
    labelFor?: string;
    labelWrap?: boolean;
    labelWidth?: number | string;
    wrapperWidth?: number | string;
    labelCol?: number;
    wrapperCol?: number;
    wrapperAlign?: 'left' | 'right';
    wrapperWrap?: boolean;
    wrapperStyle?: React.CSSProperties;
    fullness?: boolean;
    addonBefore?: React.ReactNode;
    addonAfter?: React.ReactNode;
    size?: 'small' | 'default' | 'large';
    inset?: boolean;
    extra?: React.ReactNode;
    feedbackText?: React.ReactNode;
    feedbackLayout?: 'loose' | 'terse' | 'popover' | 'none' | (string & {});
    feedbackStatus?: 'error' | 'warning' | 'success' | 'pending' | (string & {});
    feedbackIcon?: React.ReactNode;
    enableOutlineFeedback?: boolean;
    getPopupContainer?: (node: HTMLElement) => HTMLElement;
    asterisk?: boolean;
    optionalMarkHidden?: boolean;
    gridSpan?: number;
    bordered?: boolean;
}
declare type ComposeFormItem = React.FC<React.PropsWithChildren<IFormItemProps>> & {
    BaseItem?: React.FC<React.PropsWithChildren<IFormItemProps>>;
};
export declare const BaseItem: React.FC<React.PropsWithChildren<IFormItemProps>>;
export declare const FormItem: ComposeFormItem;
export default FormItem;
