"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPortalRoot = exports.createPortalProvider = void 0;
var react_1 = __importStar(require("react"));
var react_dom_1 = require("react-dom");
var reactive_1 = require("@formily/reactive");
var react_2 = require("@formily/react");
var render_1 = require("./render");
var PortalMap = (0, reactive_1.observable)(new Map());
var createPortalProvider = function (id) {
    var Portal = function (props) {
        var _a;
        var portalId = (_a = props.id) !== null && _a !== void 0 ? _a : id;
        if (portalId && !PortalMap.has(portalId)) {
            PortalMap.set(portalId, null);
        }
        return (react_1.default.createElement(react_1.Fragment, null,
            props.children,
            react_1.default.createElement(react_2.Observer, null, function () {
                if (!portalId)
                    return null;
                var portal = PortalMap.get(portalId);
                if (portal)
                    return (0, react_dom_1.createPortal)(portal, document.body);
                return null;
            })));
    };
    return Portal;
};
exports.createPortalProvider = createPortalProvider;
function createPortalRoot(host, id) {
    function render(renderer) {
        if (PortalMap.has(id)) {
            PortalMap.set(id, renderer === null || renderer === void 0 ? void 0 : renderer());
        }
        else if (host) {
            (0, render_1.render)(react_1.default.createElement(react_1.Fragment, null, renderer === null || renderer === void 0 ? void 0 : renderer()), host);
        }
    }
    function unmount() {
        var _a;
        if (PortalMap.has(id)) {
            PortalMap.set(id, null);
        }
        if (host) {
            var unmountResult = (0, render_1.unmount)(host);
            if (unmountResult && host.parentNode) {
                (_a = host.parentNode) === null || _a === void 0 ? void 0 : _a.removeChild(host);
            }
        }
    }
    return {
        render: render,
        unmount: unmount,
    };
}
exports.createPortalRoot = createPortalRoot;
//# sourceMappingURL=portal.js.map