"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayCards = void 0;
var react_1 = __importDefault(require("react"));
var antd_1 = require("antd");
var react_2 = require("@formily/react");
var classnames_1 = __importDefault(require("classnames"));
var __builtins__1 = require("../__builtins__");
var array_base_1 = require("../array-base");
var isAdditionComponent = function (schema) {
    var _a;
    return ((_a = schema['x-component']) === null || _a === void 0 ? void 0 : _a.indexOf('Addition')) > -1;
};
var isIndexComponent = function (schema) {
    var _a, _b;
    return ((_b = (_a = schema['x-component']) === null || _a === void 0 ? void 0 : _a.indexOf) === null || _b === void 0 ? void 0 : _b.call(_a, 'Index')) > -1;
};
var isRemoveComponent = function (schema) {
    var _a, _b;
    return ((_b = (_a = schema['x-component']) === null || _a === void 0 ? void 0 : _a.indexOf) === null || _b === void 0 ? void 0 : _b.call(_a, 'Remove')) > -1;
};
var isCopyComponent = function (schema) {
    var _a, _b;
    return ((_b = (_a = schema['x-component']) === null || _a === void 0 ? void 0 : _a.indexOf) === null || _b === void 0 ? void 0 : _b.call(_a, 'Copy')) > -1;
};
var isMoveUpComponent = function (schema) {
    var _a, _b;
    return ((_b = (_a = schema['x-component']) === null || _a === void 0 ? void 0 : _a.indexOf) === null || _b === void 0 ? void 0 : _b.call(_a, 'MoveUp')) > -1;
};
var isMoveDownComponent = function (schema) {
    var _a, _b;
    return ((_b = (_a = schema['x-component']) === null || _a === void 0 ? void 0 : _a.indexOf) === null || _b === void 0 ? void 0 : _b.call(_a, 'MoveDown')) > -1;
};
var isOperationComponent = function (schema) {
    return (isAdditionComponent(schema) ||
        isRemoveComponent(schema) ||
        isCopyComponent(schema) ||
        isMoveDownComponent(schema) ||
        isMoveUpComponent(schema));
};
exports.ArrayCards = (0, react_2.observer)(function (props) {
    var field = (0, react_2.useField)();
    var schema = (0, react_2.useFieldSchema)();
    var dataSource = Array.isArray(field.value) ? field.value : [];
    var prefixCls = (0, __builtins__1.usePrefixCls)('formily-array-cards', props);
    var onAdd = props.onAdd, onCopy = props.onCopy, onRemove = props.onRemove, onMoveDown = props.onMoveDown, onMoveUp = props.onMoveUp;
    if (!schema)
        throw new Error('can not found schema object');
    var renderItems = function () {
        return dataSource === null || dataSource === void 0 ? void 0 : dataSource.map(function (item, index) {
            var items = Array.isArray(schema.items)
                ? schema.items[index] || schema.items[0]
                : schema.items;
            var title = (react_1.default.createElement("span", null,
                react_1.default.createElement(react_2.RecursionField, { schema: items, name: index, filterProperties: function (schema) {
                        if (!isIndexComponent(schema))
                            return false;
                        return true;
                    }, onlyRenderProperties: true }),
                props.title || field.title));
            var extra = (react_1.default.createElement("span", null,
                react_1.default.createElement(react_2.RecursionField, { schema: items, name: index, filterProperties: function (schema) {
                        if (!isOperationComponent(schema))
                            return false;
                        return true;
                    }, onlyRenderProperties: true }),
                props.extra));
            var content = (react_1.default.createElement(react_2.RecursionField, { schema: items, name: index, filterProperties: function (schema) {
                    if (isIndexComponent(schema))
                        return false;
                    if (isOperationComponent(schema))
                        return false;
                    return true;
                } }));
            return (react_1.default.createElement(array_base_1.ArrayBase.Item, { key: index, index: index, record: function () { var _a; return (_a = field.value) === null || _a === void 0 ? void 0 : _a[index]; } },
                react_1.default.createElement(antd_1.Card, __assign({}, props, { onChange: function () { }, className: (0, classnames_1.default)("".concat(prefixCls, "-item"), props.className), title: title, extra: extra }), content)));
        });
    };
    var renderAddition = function () {
        return schema.reduceProperties(function (addition, schema, key) {
            if (isAdditionComponent(schema)) {
                return react_1.default.createElement(react_2.RecursionField, { schema: schema, name: key });
            }
            return addition;
        }, null);
    };
    var renderEmpty = function () {
        if (dataSource === null || dataSource === void 0 ? void 0 : dataSource.length)
            return;
        return (react_1.default.createElement(antd_1.Card, __assign({}, props, { onChange: function () { }, className: (0, classnames_1.default)("".concat(prefixCls, "-item"), props.className), title: props.title || field.title }),
            react_1.default.createElement(antd_1.Empty, null)));
    };
    return (react_1.default.createElement(array_base_1.ArrayBase, { onAdd: onAdd, onCopy: onCopy, onRemove: onRemove, onMoveUp: onMoveUp, onMoveDown: onMoveDown },
        renderEmpty(),
        renderItems(),
        renderAddition()));
});
exports.ArrayCards.displayName = 'ArrayCards';
array_base_1.ArrayBase.mixin(exports.ArrayCards);
exports.default = exports.ArrayCards;
//# sourceMappingURL=index.js.map