"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSize = void 0;
var useSize = function (fieldSize, searchSize, tableSize) {
    if (fieldSize === void 0) { fieldSize = 'default'; }
    var fieldSizeMap = {
        small: {
            searchSize: 'small',
            tableSize: 'small',
        },
        default: {
            searchSize: 'middle',
            tableSize: 'middle',
        },
        large: {
            searchSize: 'large',
            tableSize: 'default',
        },
    };
    var _a = fieldSizeMap[fieldSize], fieldSearchSize = _a.searchSize, fieldTableSize = _a.tableSize;
    return {
        searchSize: searchSize || fieldSearchSize,
        tableSize: tableSize || fieldTableSize,
    };
};
exports.useSize = useSize;
//# sourceMappingURL=useSize.js.map